/******************
*****Heniek*****
Sterownik DDS do trx by: 
SP9MRN - idea i core
SQ9NJE - struktury i indeksowanie VFO - bez tego projekt leżał i płakał.... 
SP9NJ - koncepcja i debugowanie CAT oraz dedykowany logger
Copyleft dla zastosowań amatorskich
For ham radio non commertial use - Copyleft

******libraries**************************/
#include <DDS.h>
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>
#include <Rotary.h>
#include <Wire.h>


//********Parametry TRX *******Hardware definition********************
// Real frequencies are divided by 10*********************************
//Częstotliwości są podzielone przez 10*******************************
const int homodyna=0;         //dla homodyny=1, dla trx z pcz=0
const long IF=900000;
const int IFoffset=150;
const int DirectCW=0;   // nadawanie CW bez przemiany, prosto z VFO
const int CWoffset=70;  //w Hz - jak nie ma to wpisac 0
long DDSfreq;

///No definition YET for DC TRX and Direct CW
//LSB: DDS = RF + IF + IFoffset   ---> RF na display, DDS do generatora
//USB: DDS = RF + IF - IFoffset
//CW : DDS = RF + IF - CWoffset CW 

//*********************************************************************

Rotary r = Rotary(2, 3);
const int stepPin=17;
const int pttPin=15;
//*********NOKIA LCD**************
const int SCLK = 4; //clock
const int DIN = 5; //data
const int DC = 6; //data/command
const int CS = 7; //chip select
const int LCDRST = 8; //reset
Adafruit_PCD8544 display = Adafruit_PCD8544(SCLK, DIN, DC, CS, LCDRST);

//*****DDS***********
const int W_CLK = 9;
const int FQ_UD = 10; 
const int DATA = 11;
const int RESET = 12;
DDS dds(W_CLK, FQ_UD, DATA, RESET);


//***************Deklaracje CAT***************
int buffget[11] ;                             // the receive buffer
int incoming;
byte sendDMHz=0;
byte sendMHz=0;
byte sendkHz=0;
byte sendHz=0;
int DMHZ = 0;
int MHZ = 0;
int KHZ = 0;
int HZ = 0;
long QRG = 0; 
int unsigned long QRGcomp = 0; 
int slowo=0;
int CTi=0;
int bandCAT=0;
//***********koniec deklaracji CAT***************/


typedef struct {
  long lower_limit;
  long upper_limit;
  long mid;
} band_t;

typedef struct {
  byte band;
  long freq[9];
  byte mode[9];
} vfo_t;

band_t bands[9] = {
  {181000, 200000, 185000},
  {350000, 380000, 370000},
  {700000, 720000, 710000},
  {1010000, 1015000, 1010000},
  {1400000, 1435000, 1425000},
  {1806800, 1816800, 1816000},
  {2100000, 2145000, 2125000},
  {2489000, 2499000, 2494000},
  {2800000, 2970000, 2850000}};

byte modes[9]={0, 0, 0, 3, 1, 1, 1, 1, 1};
 
vfo_t vfo[2];
byte active_vfo = 1;

boolean rownaj=0;
boolean split=0;
boolean ptt=0;
boolean swap=0;
int mod=0;
boolean cm=0; //change mode
int mode1=0; // current mode
int stepA=1000;
int cb=0; //change band

boolean buttonState = 0;         // current state of the button
boolean lastButtonState = 0;     // previous state of the button
boolean PTTState = 0;         // kontrola splitu
boolean lastPTTState = 1;     // kontrola splitu

int smeterLevel;
int SmeterlastLevel;

byte setATT=0; //wartosc ATT 0=nic 1=6db 2=12db 3=wzmacniacz
byte cATT=0; //czy zmieniac att

byte PCFband=1;
byte PCFmode=16;


void setup()   {
 Wire.begin();  //i2c dla expandera band switch
 pcfWrite(); // ustawienie filtrow 80m na start
  
  dds.init();  
  // (Optional) trim if your xtal is not at 125MHz...
  dds.trim(125000000); // enter actual osc freq 
  
  pinMode(13, OUTPUT);  //testowe - wyjście --> 1=TX_on
  pinMode(stepPin,INPUT_PULLUP);
  pinMode(pttPin,INPUT_PULLUP);
  
 Serial.begin(19200);
  vfo[0].band = 1;  //początkowe ustawienia pasma po starcie systemu
  vfo[1].band = 1;
    
  for(byte i=0; i<9;i++)
  {
    vfo[0].freq[i] = bands[i].mid;
    vfo[1].freq[i] = bands[i].mid;
    vfo[0].mode[i] = modes[i];
    vfo[1].mode[i] = modes[i];
  }
 //*****************deklaracja przerwan encodera******************
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();
  //****************koniec enkodera**********************
  
  display.begin();
  display.setContrast(25);
  display.clearDisplay();   // clears the screen and buffer
  display.display();
  delay(12);

/*************  
 Serial.println("*********************mode1=");
  Serial.print("mode1=");
Serial.println(mode1); 
  Serial.print("vfo[1].mode[i]=");
Serial.println(vfo[1].mode[1]);
Serial.println("*********************mode1=");
********************/

  DDSfreq=((vfo[active_vfo].freq[vfo[active_vfo].band])+IF+IFoffset)*10;
  dds.setFrequency(DDSfreq);
  printSub();
 printdodatki(); 
}



void loop() {
  //CAT();
 
 if (Serial.available() > 0){
   catread();
 }
 
  ptt=!digitalRead(pttPin); 
  buttonState = digitalRead(stepPin);
  if (buttonState != lastButtonState) {
    if (buttonState == LOW) { setstep();} 
  }
  lastButtonState = buttonState; 

/**************PTT********/
  if (ptt==0){ 
    digitalWrite(13,LOW);
    klawiatura();
    PTTState=0;
    
    //setband();
    //setmode();
  }
  
 /***************split*/
 if (split==1){  //jezeli split jest wlaczony to: 
   if(ptt==1 && PTTState==0){  // sprawdz czy jest PTT i jezeli tak to wykonaj
   splity();
  }
 if(ptt==0 && lastPTTState==0){ //reset split
    splity();
 }
 }
 /***************PTT*******/
 if (ptt==1)
 //tutaj cały ten stuff związany z nadawaniem, jakies opoznienia, przepinanie przetwornika ADC itp..
 {digitalWrite (13,HIGH);} //a to kontrolka, żeby ładnie migało
 
 
}  //_********KONIEC MAIN LOOP***to co ponizej to funkcje - czasem wywolane z main loop a czasem przez inne funkcje***************************************


//przerwania dla encodera i krecenie galka************
ISR(PCINT2_vect) {
  unsigned char result = r.process();
 if (result == DIR_NONE) {mod=0;}
  else if (result == DIR_CW) {mod=1; countfreq();}
  else if (result == DIR_CCW) {mod=-1; countfreq();}
}

//***********************Rozmowy z Katem****************
void catread(){
     incoming = Serial.read(); delay(5);
     //Serial.println("echo");
     //Serial.println(incoming);
    //display.print (incoming); display.display();
   if (incoming == 254) {
     incoming=Serial.read(); delay(5);
     if (incoming == 254){
        //display.print(incoming); display.display();
     delay(5);
   
   buffget[0] = 0;
   CTi=0;
   do{
   incoming=Serial.read();
     delay(3);
    buffget[CTi]=incoming;
   //display.print (buffget[CTi]); display.print(" "); 
   CTi++;
   } while(incoming!=253); //dopóki nie przyjdzie FD
 
  delay (5);       
 }
   }
   // display.print(CTi); display.display();
   
   //**********sprawdzamy o co chodzi loggerowi***************
   switch (CTi){
  case 4:
    CATpoll_in();
    break;
  case 5:
    CATsetmode();
    break;
  case 6:
    CATsetmode();
    break;
  case 9:
    CATsetfreq();
    break;
  }
    //Serial.print("cti-=");
     //Serial.println(CTi,HEX);
   //display.setCursor(64,20);
   //display.print(CTi);
   //display.display();
 //--------koniec CAT (main)----------------------------------
}  //Koniec CAT

//**********Ustawianie kroku przestrajania*******************
void setstep(){
  switch (stepA){ 
    case 1:
      stepA=1000;
      break;
    case 10:
      stepA=1;
      break;
    case 100:
      stepA=10;
      break;
    case 1000:
      stepA=100;
      break;
  }
  printmain();
  printSub();
  printdodatki(); 
}


//**********ATT i wzmacniacza RF*******************
//to jeszcze nie jest wyprowaszone na złącza
void set_ATT(){
  if (cATT==1){
  switch (setATT){ 
    case 0:
      setATT=1;
      break;
    case 1:
      setATT=2;
      break;
    case 2:
      setATT=3;
      break;
      case 3:
      setATT=1;
      break;
   }
  }
 cATT=0; 
  printmain();
  printSub();
  printdodatki(); 
}


//********TUNING******************************
void countfreq(){
  vfo[active_vfo].freq[vfo[active_vfo].band] += stepA * mod;
  
  if(vfo[active_vfo].freq[vfo[active_vfo].band] < bands[vfo[active_vfo].band].lower_limit)
    vfo[active_vfo].freq[vfo[active_vfo].band] = bands[vfo[active_vfo].band].lower_limit;
    
  if(vfo[active_vfo].freq[vfo[active_vfo].band] > bands[vfo[active_vfo].band].upper_limit)
    vfo[active_vfo].freq[vfo[active_vfo].band] = bands[vfo[active_vfo].band].upper_limit; 
    
 // Serial.println(vfo[active_vfo].freq[vfo[active_vfo].band]);
 //kejsy LSB USB CW (0,1,3) i send to DDS do dodania CW reverse nr 7
 
 //przeliczamy czestotliwosc w zaleznosci od emisji 0=cw, 1=lsb, 3=usb
 switch(mode1){
      case 0:
            DDSfreq=((vfo[active_vfo].freq[vfo[active_vfo].band])+IF+IFoffset)*10;
            break;
      case 1:
            DDSfreq=((vfo[active_vfo].freq[vfo[active_vfo].band])+IF-IFoffset)*10;
            break;
      case 3:
            DDSfreq=((vfo[active_vfo].freq[vfo[active_vfo].band])+IF-CWoffset)*10;
            break;
 }
 dds.setFrequency(DDSfreq); // tu sie wysyla przeliczona zadana czestotliwosc do DDSa
 printmain(); //tu na wyswietlacz idzie tylko gorne vfo (main), bo inaczej nie nadaza z przerwaniami
 //docelowo ma byc mozliwosc ustawiania tez dolnego (sub)
}

//**********BAND***************
void setband(){
  if ((cb==1)&&(vfo[active_vfo].band==8)) 
  {
    vfo[active_vfo].band=0; 
    cb=0;
  }
  if ((cb==1)&&(vfo[active_vfo].band <8)) 
  {
    vfo[active_vfo].band++; 
    cb=0;
  } 
  if ((cb==-1)&&(vfo[active_vfo].band==0)) 
  {
    vfo[active_vfo].band=8; 
    cb=0;
  }
  if ((cb==-1)&&(vfo[active_vfo].band >0)) 
  {
    vfo[active_vfo].band--; 
    cb=0;
  }
  //ustawianie portów ekspandera dla filtrów
  PCFband=(vfo[active_vfo].band);
     setmode();  //przejdz do ustawiania mode
   
}

//**********MODE***************
void setmode(){
 /****************Serial.println("*********************CM=");
  Serial.print("CM=");
Serial.println(cm); 
Serial.println("*********************CM=");
  ******************************/
  if (cm==1)
 {   
     if(vfo[active_vfo].mode[vfo[active_vfo].band]==0) {vfo[active_vfo].mode[vfo[active_vfo].band]++;} 
     else if(vfo[active_vfo].mode[vfo[active_vfo].band]==1) {vfo[active_vfo].mode[vfo[active_vfo].band]+=2;}
     else if (vfo[active_vfo].mode[vfo[active_vfo].band]==3) {(vfo[active_vfo].mode[vfo[active_vfo].band])=0;}
     //mode+1 = (0,1,2)
     //else {vfo[active_vfo].mode[vfo[active_vfo].band]=0;}
  //Serial.println(vfo[active_vfo].mode[vfo[active_vfo].band]);
 cm=0;
  }
  mode1= vfo[active_vfo].mode[vfo[active_vfo].band];
 
  switch(mode1){
          case 0:
            DDSfreq=((vfo[active_vfo].freq[vfo[active_vfo].band])+IF+IFoffset)*10;
            PCFmode=16;
                      break;
            case 1:
            DDSfreq=((vfo[active_vfo].freq[vfo[active_vfo].band])+IF-IFoffset)*10;
            PCFmode=32;
            
            break;
            case 3:
            DDSfreq=((vfo[active_vfo].freq[vfo[active_vfo].band])+IF-CWoffset)*10;
            PCFmode=64;
            
            break;
 }
 pcfWrite();
 dds.setFrequency(DDSfreq);

   printmain();
  printSub();
  printdodatki();
}

//****************Zamiana VfoA i VfoB
void swapy(){
  //z klawiatury przychodzi VFOA==1 lub VFO==0
  if (rownaj==1){
    vfo[1-active_vfo].band = vfo[active_vfo].band;
    vfo[1-active_vfo].freq[vfo[1-active_vfo].band] = vfo[active_vfo].freq[vfo[active_vfo].band];
    vfo[1-active_vfo].mode[vfo[1-active_vfo].band] = vfo[active_vfo].mode[vfo[active_vfo].band];
  }
  else 
    active_vfo = 1 - active_vfo;
  setmode(); 
}









//*******************Obsluga split*******************
void splity(){
   if(ptt==1){
   PTTState=1;
   lastPTTState=0;
 }
else {lastPTTState=1;}
  swapy(); //zeby sie nie powtarzac to idzie do swapow - bo w rzecawistosci split to chwilowy swap wymuszony przez PTT
} 


//***********zapis do PCF****************
//***tedy wychodza informacje o pasmach (4 bity), o modach(3 piny) i jeden mam jeszcze wolny
//pierwsze 4 bity (od 0-15)(waga1,2,4,8) to pasmo, nastepne 3 (16,32,64) to mode
void pcfWrite()
{
Wire.beginTransmission(0x20);
byte PCFtransmit=PCFband+PCFmode;
Wire.write(PCFtransmit);
Wire.endTransmission();
/****Serial.print("PCF=");
Serial.println(PCFtransmit);
Serial.print("pasmo=");
Serial.print(PCFband);
Serial.print(", mode=");
Serial.print(PCFmode);
Serial.print(", realmode=");
Serial.println(mode1);
Serial.print("CM=");
Serial.println(cm);
Serial.println();
Serial.print("PCFbinarnie=");
Serial.println(PCFtransmit,BIN);**********/
}
 
